<template>
  <button-default
      v-if="page > 1"
      @click="page = page - 1"
  >
    Prev
  </button-default>
  <button-default
      v-if="hasNextPage"
      @click="page = page + 1"
  >
    Next
  </button-default>
</template>

<script>
import DefaultButton from "@/components/stock/DefaultButton";

export default {
  name: "Pagination",

  props: {
    tickersLimit: {
      type: Number,
      required: true
    },
    tickersList: {
      type: Array,
      required: true
    },
    resetPagination: Boolean,
    initialPageState: Number
  },

  emits: ["paginationUpdated"],

  components: {
    "button-default": DefaultButton
  },

  data() {
    return {
      page: this.initialPageState
    }
  },

  computed: {
    paginatedTickers() {
      const pageStartIndex = (this.page - 1) * this.tickersLimit;
      const pageEndIndex = this.page * this.tickersLimit;
      return this.tickersList.slice(pageStartIndex, pageEndIndex);
    },

    hasNextPage() {
      return this.tickersList.length > this.page * this.tickersLimit;
    }
  },

  watch: {
    resetFilter() {
      if (this.resetFilter) {
        this.page = 1
      }
    },

    paginatedTickers() {
      if (this.paginatedTickers.length === 0 && this.page > 1) {
        this.page -= 1;
      } else {
        this.$emit("paginationUpdated", {
              paginatedTickers: this.paginatedTickers,
              currentPage: this.page
            }
        );
      }
    }
  },

  mounted() {
    this.$emit("paginationUpdated", this.paginatedTickers);
  }
}
</script>

<style scoped>

</style>